/***************************************************************
*   File name    :  sgp30.c  
*****************************************************************/
#include "STC15W4K32S4.h"
#include "sgp30.H" //SHTC3 head file 
#include "delay.h"
void delay_ms(uint);
/*================================================================
  Name  Pin Description
FunctionģIICʹõŶ
  Notes 
================================================================*/
/*************Pin Description*************
   SCL -P1.0     
   SDA -P1.1
*****************************************/
sbit SCL = P1^0;
sbit SDA = P1^1;

/*================================================================
  Name  
FunctionӦλƽ
  Notes 
================================================================*/
#define ACK         0             //Ӧź
#define NACK        1             //Ӧź
/*------------------------------------------------------------*/
/*================================================================
  Name  void I2CDelay (uchar t)
FunctionģIICõĶʱ us
  Notes 
================================================================*/
void I2CDelay (uchar t)          
{
        while(t--);
}

/*================================================================
  Name  void I2CStart(void)
FunctionI2Cʼź
  Notes SCLSDAͬΪߣSDAɵ֮SCLɵ          
================================================================*/
void I2CStart(void)
{        
          SDA = 1;                            //ʼź--ZLG
          SCL = 1;
          I2CDelay(50);                    //ʼʱ4.7us,ʱ--ZLG
          SDA = 0;                            //ʼź-ZLG
					I2CDelay(50);                    //ʼʱ4s--ZLG
          SCL = 0;                            //ǯסI2Cߣ׼ͻ--ZLG
					I2CDelay(50);         
}

/*================================================================
  Name  void I2CStop(void)
FunctionI2Cֹͣź
  Notes SCLSDAͬΪͣSCLɸ֮SDAɸ           
================================================================*/
void I2CStop(void)
{        
          SDA = 0;                        //ͽź--ZLG
          SCL = 0;
					I2CDelay(50);
          SCL = 1;                        //ͽʱź--ZLG
          I2CDelay(50);                //ʱ4s--ZLG
          SDA = 1;                        //I2C߽ź--ZLG
          I2CDelay(50); 
}

/*================================================================
  Name  uchar I2C_Write_Byte(uchar WRByte)
FunctionI2CдһֽݣACKNACK
  Notes Ӹߵͣη
================================================================*/
uchar I2C_Write_Byte(uchar Write_Byte)  //Sendbyte
{
        uchar i;   
				SCL=0;	
				I2CDelay(10); 
        for(i=0;i<8;i++)              //Ҫ͵ݳΪ8λ--ZLG
        {         
							if(Write_Byte&0x80)   //жϷλ--ZLG
							{
											SDA = 1;        
							}
							else
							{
											SDA = 0;
							}
							I2CDelay(5);                
							SCL=1;                //SDAȶSCLأӻ⵽ݲ      
							I2CDelay(5);         //֤ʱӸߵƽڴ4s--ZLG
							SCL=0;
							I2CDelay(5);
							Write_Byte <<= 1;
        } 
        I2CDelay(1);
        SDA = 1;                      //8λͷߣ׼Ӧλ-ZLG
				I2CDelay(40);
				SCL = 1;                      //MCU֪SHT2XݷϣȴӻӦź        
        I2CDelay(40);                   
        /*жI2C߽ӦӦźACKNACK*/
        if(SDA==1)                                   //SDAΪߣյNACK
				{
					  SCL=0;
						return NACK;   
					  I2CDelay(40); 
				}        
        else                                         //SDAΪͣյACK 
				{
					  SCL=0;
						return ACK;  
					  I2CDelay(40); 
				}	 
}

/*================================================================
  Name  uchar I2C_Read_Byte(uchar AckValue)
FunctionI2CһֽݣڲڿӦ״̬ACKNACK
  Notes Ӹߵͣν
================================================================*/
uchar I2C_Read_Byte(uchar AckValue)//receivebyte
{
        uchar i,RDByte=0;
        SCL=0;                                   //ʱΪͣ׼λ--ZLG
				I2CDelay(40);  
        SDA = 1;                                 //ͷ,Ϊ뷽ʽ--ZLG        
        for (i=0;i<8;i++) 
        {        
                SCL = 1;                          //SCLߵƽڼ䣬ɼSDAźţΪЧ //ʱΪʹЧ--ZLG 
                I2CDelay(20);
                RDByte <<= 1;                  //λ
                if(SDA==1)                           //ȡ
                {
                        RDByte |= 0x01;
                }
                else
                {
                        RDByte &= 0xfe;
                }
                I2CDelay(10);
                SCL = 0;                             //½أӻһλֵ
                I2CDelay(60);
        }   
        /*I2C߷ӦźACKNACK*/
        SDA = AckValue;                      //Ӧ״̬        
        I2CDelay(30);
        SCL = 1;                         
        I2CDelay(50);                  //ʱӵ͵ƽڴ4s--ZLG
        SCL = 0;                                  //ʱߣǯסI2CԱ--ZLG               
        I2CDelay(150);       
        return RDByte;
}


//ʼIICӿ
void SGP30_Init(void)
{
	SGP30_ad_write(0x20,0x03);
//	SGP30_ad_write(0x20,0x61);
//	SGP30_ad_write(0x01,0x00);
}

void SGP30_ad_write(uchar a, uchar b)
{
  	I2CStart();
  	I2C_Write_Byte(SGP30_write); //ַ+дָ
  	I2C_Write_Byte(a);		//Ϳֽ
		I2C_Write_Byte(b);
		I2CStop();
		delay_ms(100);
}

unsigned long SGP30_ad_read(void)
{
  	unsigned long dat;
		int crc;
  	I2CStart();
  	I2C_Write_Byte(SGP30_read); //ַ+ָ
  	dat = I2C_Read_Byte(ACK);
		dat <<= 8;
		dat += I2C_Read_Byte(ACK);
		crc = I2C_Read_Byte(ACK); //checkݣȥ
		crc = crc;             //棬п
		dat <<= 8;
		dat += I2C_Read_Byte(ACK);
		dat <<= 8;
		dat += I2C_Read_Byte(NACK);
  	I2CStop();
  	return(dat);
}
